"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _babelPluginMacros = require("babel-plugin-macros");

var _path = _interopRequireDefault(require("path"));

var _hash = _interopRequireDefault(require("./hash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function uniqueClassnameMacro(_ref) {
  var references = _ref.references,
      state = _ref.state,
      babel = _ref.babel;
  var t = babel.types;
  var filePath = state.file.opts.filename;

  var fileName = _path.default.basename(filePath);

  references.default.forEach(function (referencePath) {
    var parentPath = referencePath.findParent(t.isCallExpression);
    var variableName = referencePath.findParent(t.isVariableDeclarator).node.id.name;

    if (parentPath.node.arguments.length > 0 && parentPath.node.arguments[0] !== '') {
      variableName = parentPath.node.arguments[0].value;
    }

    var newName = "".concat(fileName, "-").concat(variableName);
    var newUid = referencePath.scope.generateUidIdentifier(newName).name;
    parentPath.replaceWith(t.stringLiteral("".concat(variableName, "-").concat((0, _hash.default)(newUid))));
  });
}

var _default = (0, _babelPluginMacros.createMacro)(uniqueClassnameMacro);

exports.default = _default;